-----------------------------------------------------------------------------
-- |
-- Module      :  System.Win32
-- Copyright   :  (c) Alastair Reid, 1999-2003
-- License     :  BSD-style (see the file libraries/base/LICENSE)
-- 
-- Maintainer  :  libraries@haskell.org
-- Stability   :  provisional
-- Portability :  portable
--
-- An ffi binding to the Win32 API.
--
-----------------------------------------------------------------------------

module System.Win32
	( module Foreign.GreenCard
	, module System.Win32.GDITypes
	, module System.Win32.Bitmap
	, module System.Win32.Brush
	, module System.Win32.Control
	, module System.Win32.Clip
	, module System.Win32.Dialogue
	, module System.Win32.DLL
	, module System.Win32.File
	, module System.Win32.Font
	, module System.Win32.Graphics2D
	, module System.Win32.HDC
	, module System.Win32.Icon
	, module System.Win32.Key
	, module System.Win32.Menu
	, module System.Win32.Misc
	, module System.Win32.MM
	, module System.Win32.Palette
	, module System.Win32.Path
	, module System.Win32.Pen
	, module System.Win32.Process
	, module System.Win32.Region
	, module System.Win32.Registry
	, module System.Win32.SystemInfo
	, module System.Win32.Types
	, module System.Win32.WinMessage
	, module System.Win32.Window
	) where

import Foreign.GreenCard
import System.Win32.GDITypes
import System.Win32.Bitmap
import System.Win32.Brush
import System.Win32.Clip
import System.Win32.Control
import System.Win32.Dialogue
import System.Win32.DLL
import System.Win32.File
import System.Win32.Font
import System.Win32.Graphics2D
import System.Win32.HDC
import System.Win32.Icon
import System.Win32.Key
import System.Win32.Menu
import System.Win32.Misc
import System.Win32.MM
import System.Win32.Palette
import System.Win32.Path
import System.Win32.Pen
import System.Win32.Process
import System.Win32.Region
import System.Win32.Registry
import System.Win32.SystemInfo
import System.Win32.Types
import System.Win32.WinMessage
import System.Win32.Window

----------------------------------------------------------------
-- End
----------------------------------------------------------------
